<template>
<div>
	{{listaLugares}}
	<el-select v-if="!cargaManual" v-model="CalleObject"  value-key="nombre" 
		:disabled="disabled"
		:placeholder="placeholder" filterable default-first-option >
		<template>
			<el-option-group v-if="frecuentes" label="Frecuentes">
				<el-option 
					v-for="item in listaFrecuentes"
					:key="`${item.nombre}-${item.localidad}`" :label="`${item.nombre}`"
					:value="{...item}">
					<span>{{item.nombre}}, {{item.localidad}}</span>
				</el-option>
			</el-option-group>
			<el-option-group v-if="lugares" label="Lugares">
				<el-option 
					v-for="item in listaLugares"
					:key="`${item.nombre}-${item.localidad}`" :label="`${item.nombre}`"
					:value="{...item}">
					<span>{{item.nombre}}, {{item.localidad}}</span>
				</el-option>
			</el-option-group>
			<el-option-group v-if="calles" label="Calles">
				<el-option
					v-for="item in listaCalles"
					:key="`${item.nombre}-${item.localidad}`"
					value-key="nombre" :label="`${item.nombre}`"
					:value="{...item}">
					<span>{{item.nombre}}, {{item.localidad}}</span>
				</el-option>
			</el-option-group>
		</template>
		<template v-slot:empty>
			<span></span>
				<el-button size="mini" @click="cargaManual = true">Agregar</el-button>
		</template>
	</el-select>
	<el-input v-else
		v-model="CalleStr"
		:placeholder="placeholder"
		:disabled="disabled"

	>
		<el-select v-model="tipoOrigen" v-slot-prepend :placeholder="placeholder" 
			class="select-prepend" default-first-option>
			<el-option v-if="lugares" label="Lugar" value="Lugar"></el-option>
			<el-option v-if="calles" label="Calle" value="Calle"></el-option>
		</el-select>
	</el-input>
	</div>
</template>
<script>

import lugares from '@/model/lugares'


export default {
	props: {
		value: String,
		lugares: Boolean,
		calles: Boolean,
		frecuentes: Boolean,
		placeholder: String,
		/** Indica que sólo se debe cargar la lista de calles si no fue cargada antes */
		lazy: Boolean, 
		disabled: Boolean,
	},
	created() {
		if(this.RESOURCE_LIST.length == 0) {
			this.fetchLugares()
		}	
	},
	computed: {
		CalleObject: {
			get(){
				return {nombre: this.value}
			},
			set(v) {
				this.$emit('input',v.nombre)
				this.$emit('change',v.nombre)
				this.$emit('select',v)
			}
		},
		CalleStr: {
			get(){
				return this.value
			},
			set(v) {
				this.$emit('input',v)
				this.$emit('change',v)
				this.$emit('select',{nombre: v, tipo: this.tipoOrigen})
			}
		},

		listaLugares() {
			console.log('listaLugares', this.RESOURCE_LIST)
			return Array.isArray(this.RESOURCE_LIST) ? this.RESOURCE_LIST.filter(l=>l.tipo == 'Lugar' && !l.frecuente) : []
		},
		listaCalles() {
			console.log('listaCalles', this.RESOURCE_LIST)
			return Array.isArray(this.RESOURCE_LIST) ? this.RESOURCE_LIST.filter(l=>l.tipo == 'Calle' && !l.frecuente) : []
		},
		listaFrecuentes() {
			console.log('listaFrecuentes', this.RESOURCE_LIST)
			return Array.isArray(this.RESOURCE_LIST) ? this.RESOURCE_LIST.filter(l=>l.frecuente) : []
		},
	},
	methods: {
		async fetchLugares() {
			if(this.RESOURCE_LIST.length>0 && this.lazy) {
				return
			}
			const filtros = []
			if(this.lugares) {
				filtros.push(`tipo=Lugar`)
			}
			
			if(this.calles) {
				filtros.push(`tipo=Calle`)
			}
			console.log('fetch')
			lugares.fetch({	filters: filtros,	sort: ['tipo','nombre'], context: 'select-lugar', cacheTimeout: 60})
			.then((response)=>{
				this.RESOURCE_LIST = response.value
			})
		}
	},
	data() {
		return {
			cargaManual: false,
			tipoOrigen: 'Calle',
			RESOURCE_LIST: [],
		}
	}
	
}
</script>
<style scoped>
.select-prepend {
	width: 90px;
}

</style>